## mercurial 5.3.1

=== Makefile ===
# If you want to change PREFIX, do not just edit it below. The changed
# value wont get passed on to recursive make calls. You should instead
# override the variable on the command like:
#
# % make PREFIX=/opt/ install

export PREFIX=/usr/local
PYTHON?=python
$(eval HGROOT := $(shell pwd))
HGPYTHONS ?= $(HGROOT)/build/pythons
PURE=
PYFILESCMD=find mercurial hgext doc -name '*.py'
PYFILES:=$(shell $(PYFILESCMD))
DOCFILES=mercurial/helptext/*.txt
export LANGUAGE=C
export LC_ALL=C
TESTFLAGS ?= $(shell echo $$HGTESTFLAGS)
OSXVERSIONFLAGS ?= $(shell echo $$OSXVERSIONFLAGS)
CARGO = cargo

# Set this to e.g. "mingw32" to use a non-default compiler.
COMPILER=

COMPILERFLAG_tmp_ =
COMPILERFLAG_tmp_${COMPILER} ?= -c $(COMPILER)
COMPILERFLAG=${COMPILERFLAG_tmp_${COMPILER}}

help:
	@echo 'Commonly used make targets:'
	@echo '  all          - build program and documentation'
	@echo '  install      - install program and man pages to $$PREFIX ($(PREFIX))'
	@echo '  install-home - install with setup.py install --home=$$HOME ($(HOME))'
	@echo '  local        - build for inplace usage'
	@echo '  tests        - run all tests in the automatic test suite'
	@echo '  test-foo     - run only specified tests (e.g. test-merge1.t)'
	@echo '  dist         - run all tests and create a source tarball in dist/'
	@echo '  clean        - remove files created by other targets'
	@echo '                 (except installed files or dist source tarball)'
	@echo '  update-pot   - update i18n/hg.pot'
	@echo
	@echo 'Example for a system-wide installation under /usr/local:'
	@echo '  make all && su -c "make install" && hg version'
	@echo
	@echo 'Example for a local installation (usable in this directory):'
	@echo '  make local && ./hg version'

all: build doc

local:
	$(PYTHON) setup.py $(PURE) \
	  build_py -c -d . \
	  build_ext $(COMPILERFLAG) -i \
	  build_hgexe $(COMPILERFLAG) -i \
	  build_mo
	env HGRCPATH= $(PYTHON) hg version

build:
	$(PYTHON) setup.py $(PURE) build $(COMPILERFLAG)

wheel:
	FORCE_SETUPTOOLS=1 $(PYTHON) setup.py $(PURE) bdist_wheel $(COMPILERFLAG)

doc:
	$(MAKE) -C doc

cleanbutpackages:
	-$(PYTHON) setup.py clean --all # ignore errors from this command
	find contrib doc hgext hgext3rd i18n mercurial tests hgdemandimport \
		\( -name '*.py[cdo]' -o -name '*.so' \) -exec rm -f '{}' ';'
	rm -f MANIFEST MANIFEST.in hgext/__index__.py tests/*.err
	rm -f mercurial/__modulepolicy__.py
	if test -d .hg; then rm -f mercurial/__version__.py; fi
	rm -rf build mercurial/locale
	$(MAKE) -C doc clean
	$(MAKE) -C contrib/chg distclean
	rm -rf rust/target
	rm -f mercurial/rustext.so

clean: cleanbutpackages
	rm -rf packages

install: install-bin install-doc

install-bin: build
	$(PYTHON) setup.py $(PURE) install --root="$(DESTDIR)/" --prefix="$(PREFIX)" --force

install-doc: doc
	cd doc && $(MAKE) $(MFLAGS) install

install-home: install-home-bin install-home-doc

install-home-bin: build
	$(PYTHON) setup.py $(PURE) install --home="$(HOME)" --prefix="" --force

install-home-doc: doc
	cd doc && $(MAKE) $(MFLAGS) PREFIX="$(HOME)" install

MANIFEST-doc:
	$(MAKE) -C doc MANIFEST

MANIFEST.in: MANIFEST-doc
	hg manifest | sed -e 's/^/include /' > MANIFEST.in
	echo include mercurial/__version__.py >> MANIFEST.in
	sed -e 's/^/include /' < doc/MANIFEST >> MANIFEST.in

dist:	tests dist-notests

dist-notests:	doc MANIFEST.in
	TAR_OPTIONS="--owner=root --group=root --mode=u+w,go-w,a+rX-s" $(PYTHON) setup.py -q sdist

check: tests

tests:
        # Run Rust tests if cargo is installed
	if command -v $(CARGO) >/dev/null 2>&1; then \
		$(MAKE) rust-tests; \
	fi
	cd tests && $(PYTHON) run-tests.py $(TESTFLAGS)

test-%:
	cd tests && $(PYTHON) run-tests.py $(TESTFLAGS) $@

testpy-%:
	@echo Looking for Python $* in $(HGPYTHONS)
	[ -e $(HGPYTHONS)/$*/bin/python ] || ( \
	cd $$(mktemp --directory --tmpdir) && \
        $(MAKE) -f $(HGROOT)/contrib/Makefile.python PYTHONVER=$* PREFIX=$(HGPYTHONS)/$* python )
	cd tests && $(HGPYTHONS)/$*/bin/python run-tests.py $(TESTFLAGS)

rust-tests: py_feature = $(shell $(PYTHON) -c \
 'import sys; print(["python27-bin", "python3-bin"][sys.version_info[0] >= 3])')
rust-tests:
	cd $(HGROOT)/rust/hg-cpython \
		&& $(CARGO) test --quiet --all \
			--no-default-features --features "$(py_feature)"

check-code:
	hg manifest | xargs python contrib/check-code.py

format-c:
	clang-format --style file -i \
	  `hg files 'set:(**.c or **.cc or **.h) and not "listfile:contrib/clang-format-ignorelist"'`

update-pot: i18n/hg.pot

i18n/hg.pot: $(PYFILES) $(DOCFILES) i18n/posplit i18n/hggettext
	$(PYTHON) i18n/hggettext mercurial/commands.py \
	  hgext/*.py hgext/*/__init__.py \
	  mercurial/fileset.py mercurial/revset.py \
	  mercurial/templatefilters.py \
	  mercurial/templatefuncs.py \
	  mercurial/templatekw.py \
	  mercurial/filemerge.py \
	  mercurial/hgweb/webcommands.py \
	  mercurial/util.py \
	  $(DOCFILES) > i18n/hg.pot.tmp
        # All strings marked for translation in Mercurial contain
        # ASCII characters only. But some files contain string
        # literals like this '\037\213'. xgettext thinks it has to
        # parse them even though they are not marked for translation.
        # Extracting with an explicit encoding of ISO-8859-1 will make
        # xgettext "parse" and ignore them.
	$(PYFILESCMD) | xargs \
	  xgettext --package-name "Mercurial" \
	  --msgid-bugs-address "<mercurial-devel@mercurial-scm.org>" \
	  --copyright-holder "Matt Mackall <mpm@selenic.com> and others" \
	  --from-code ISO-8859-1 --join --sort-by-file --add-comments=i18n: \
	  -d hg -p i18n -o hg.pot.tmp
	$(PYTHON) i18n/posplit i18n/hg.pot.tmp
        # The target file is not created before the last step. So it never is in
        # an intermediate state.
	mv -f i18n/hg.pot.tmp i18n/hg.pot

%.po: i18n/hg.pot
        # work on a temporary copy for never having a half completed target
	cp $@ $@.tmp
	msgmerge --no-location --update $@.tmp $^
	mv -f $@.tmp $@

# Packaging targets

packaging_targets := \
  centos5 \
  centos6 \
  centos7 \
  centos8 \
  deb \
  docker-centos5 \
  docker-centos6 \
  docker-centos7 \
  docker-centos8 \
  docker-debian-bullseye \
  docker-debian-buster \
  docker-debian-stretch \
  docker-fedora \
  docker-ubuntu-trusty \
  docker-ubuntu-trusty-ppa \
  docker-ubuntu-xenial \
  docker-ubuntu-xenial-ppa \
  docker-ubuntu-artful \
  docker-ubuntu-artful-ppa \
  docker-ubuntu-bionic \
  docker-ubuntu-bionic-ppa \
  fedora \
  linux-wheels \
  linux-wheels-x86_64 \
  linux-wheels-i686 \
  ppa

# Forward packaging targets for convenience.
$(packaging_targets):
	$(MAKE) -C contrib/packaging $@

osx:
	rm -rf build/mercurial
	/usr/bin/python2.7 setup.py install --optimize=1 \
	  --root=build/mercurial/ --prefix=/usr/local/ \
	  --install-lib=/Library/Python/2.7/site-packages/
	make -C doc all install DESTDIR="$(PWD)/build/mercurial/"
        # Place a bogon .DS_Store file in the target dir so we can be
        # sure it doesn't get included in the final package.
	touch build/mercurial/.DS_Store
        # install zsh completions - this location appears to be
        # searched by default as of macOS Sierra.
	install -d build/mercurial/usr/local/share/zsh/site-functions/
	install -m 0644 contrib/zsh_completion build/mercurial/usr/local/share/zsh/site-functions/_hg
        # install bash completions - there doesn't appear to be a
        # place that's searched by default for bash, so we'll follow
        # the lead of Apple's git install and just put it in a
        # location of our own.
	install -d build/mercurial/usr/local/hg/contrib/
	install -m 0644 contrib/bash_completion build/mercurial/usr/local/hg/contrib/hg-completion.bash
	make -C contrib/chg \
	  HGPATH=/usr/local/bin/hg \
	  PYTHON=/usr/bin/python2.7 \
	  HGEXTDIR=/Library/Python/2.7/site-packages/hgext \
	  DESTDIR=../../build/mercurial \
	  PREFIX=/usr/local \
	  clean install
	mkdir -p $${OUTPUTDIR:-dist}
	HGVER=$$(python contrib/genosxversion.py $(OSXVERSIONFLAGS) build/mercurial/Library/Python/2.7/site-packages/mercurial/__version__.py) && \
	OSXVER=$$(sw_vers -productVersion | cut -d. -f1,2) && \
	pkgbuild --filter \\.DS_Store --root build/mercurial/ \
	  --identifier org.mercurial-scm.mercurial \
	  --version "$${HGVER}" \
	  build/mercurial.pkg && \
	productbuild --distribution contrib/packaging/macosx/distribution.xml \
	  --package-path build/ \
	  --version "$${HGVER}" \
	  --resources contrib/packaging/macosx/ \
	  "$${OUTPUTDIR:-dist/}"/Mercurial-"$${HGVER}"-macosx"$${OSXVER}".pkg

.PHONY: help all local build doc cleanbutpackages clean install install-bin \
	install-doc install-home install-home-bin install-home-doc \
	dist dist-notests check tests rust-tests check-code format-c \
	update-pot \
	$(packaging_targets) \
	osx

=== doc/Makefile ===
SOURCES=$(notdir $(wildcard ../mercurial/helptext/*.[0-9].txt))
MAN=$(SOURCES:%.txt=%)
HTML=$(SOURCES:%.txt=%.html)
GENDOC=gendoc.py ../mercurial/commands.py ../mercurial/help.py \
	../mercurial/helptext/*.txt ../hgext/*.py ../hgext/*/__init__.py
PREFIX=/usr/local
MANDIR=$(PREFIX)/share/man
INSTALL=install -c -m 644
PYTHON?=python
RSTARGS=

export HGENCODING=UTF-8

all: man html

man: $(MAN)

html: $(HTML)

# This logic is duplicated in setup.py:hgbuilddoc()
common.txt $(SOURCES) $(SOURCES:%.txt=%.gendoc.txt): $(GENDOC)
	${PYTHON} gendoc.py "$(basename $@)" > $@.tmp
	mv $@.tmp $@

%: %.txt %.gendoc.txt common.txt
	$(PYTHON) runrst hgmanpage $(RSTARGS) --halt warning \
	  --strip-elements-with-class htmlonly $*.txt $*

%.html: %.txt %.gendoc.txt common.txt
	$(PYTHON) runrst html $(RSTARGS) --halt warning \
	  --link-stylesheet --stylesheet-path style.css $*.txt $*.html

MANIFEST: man html
# tracked files are already in the main MANIFEST
	$(RM) $@
	for i in $(MAN) $(HTML); do \
	  echo "doc/$$i" >> $@ ; \
	done

install: man
	for i in $(MAN) ; do \
	  subdir=`echo $$i | sed -n 's/^.*\.\([0-9]\)$$/man\1/p'` ; \
	  mkdir -p "$(DESTDIR)$(MANDIR)"/$$subdir ; \
	  $(INSTALL) $$i "$(DESTDIR)$(MANDIR)"/$$subdir ; \
	done

clean:
	$(RM) $(MAN) $(HTML) common.txt $(SOURCES) $(SOURCES:%.txt=%.gendoc.txt) MANIFEST

=== contrib/fuzz/Makefile ===
CC = clang
CXX = clang++

# By default, use our own standalone_fuzz_target_runner.
# This runner does no fuzzing, but simply executes the inputs
# provided via parameters.
# Run e.g. "make all LIB_FUZZING_ENGINE=/path/to/libFuzzer.a"
# to link the fuzzer(s) against a real fuzzing engine.
#
# OSS-Fuzz will define its own value for LIB_FUZZING_ENGINE.
LIB_FUZZING_ENGINE ?= standalone_fuzz_target_runner.o

PYTHON_CONFIG ?= $$OUT/sanpy/bin/python-config

CXXFLAGS += -Wno-deprecated-register

all: standalone_fuzz_target_runner.o oss-fuzz

standalone_fuzz_target_runner.o: standalone_fuzz_target_runner.cc

$$OUT/%_fuzzer_seed_corpus.zip: %_corpus.py
	python $< $@

pyutil.o: pyutil.cc pyutil.h
	$(CXX) $(CXXFLAGS) -g -O1 \
	  `$(PYTHON_CONFIG) --cflags` \
	  -I../../mercurial -c -o pyutil.o pyutil.cc

bdiff-oss-fuzz.o: ../../mercurial/bdiff.c
	$(CC) $(CFLAGS) -c -o bdiff-oss-fuzz.o ../../mercurial/bdiff.c

bdiff_fuzzer: bdiff.cc bdiff-oss-fuzz.o
	$(CXX) $(CXXFLAGS) -std=c++17 -I../../mercurial bdiff.cc \
	  bdiff-oss-fuzz.o $(LIB_FUZZING_ENGINE) -o \
	  $$OUT/bdiff_fuzzer

mpatch.o: ../../mercurial/mpatch.c
	$(CC) -g -O1 -fsanitize=fuzzer-no-link,address -c -o mpatch.o \
	  ../../mercurial/mpatch.c

mpatch-oss-fuzz.o: ../../mercurial/mpatch.c
	$(CC) $(CFLAGS) -c -o mpatch-oss-fuzz.o ../../mercurial/mpatch.c

mpatch_fuzzer: mpatch.cc mpatch-oss-fuzz.o $$OUT/mpatch_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) -std=c++17 -I../../mercurial mpatch.cc \
	  mpatch-oss-fuzz.o $(LIB_FUZZING_ENGINE) -o \
	  $$OUT/mpatch_fuzzer

fuzz-x%.o: ../../mercurial/thirdparty/xdiff/x%.c ../../mercurial/thirdparty/xdiff/*.h
	$(CC) $(CFLAGS) -c \
	  -o $@ \
	  $<

xdiff_fuzzer: xdiff.cc fuzz-xdiffi.o fuzz-xprepare.o fuzz-xutils.o 
	$(CXX) $(CXXFLAGS) -std=c++17 -I../../mercurial xdiff.cc \
	  fuzz-xdiffi.o fuzz-xprepare.o fuzz-xutils.o \
	  $(LIB_FUZZING_ENGINE) -o $$OUT/xdiff_fuzzer

parsers-%.o: ../../mercurial/cext/%.c
	$(CC) -I../../mercurial `$(PYTHON_CONFIG) --cflags` $(CFLAGS) -c \
	  -o $@ $<

PARSERS_OBJS=parsers-manifest.o parsers-charencode.o parsers-parsers.o parsers-dirs.o parsers-pathencode.o parsers-revlog.o

dirs_fuzzer: dirs.cc pyutil.o $(PARSERS_OBJS) $$OUT/dirs_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial dirs.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/dirs_fuzzer

fncache_fuzzer: fncache.cc 
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial fncache.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/fncache_fuzzer

jsonescapeu8fast_fuzzer: jsonescapeu8fast.cc pyutil.o $(PARSERS_OBJS)
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial jsonescapeu8fast.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/jsonescapeu8fast_fuzzer

manifest_fuzzer: manifest.cc pyutil.o $(PARSERS_OBJS) $$OUT/manifest_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial manifest.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/manifest_fuzzer

revlog_fuzzer: revlog.cc pyutil.o $(PARSERS_OBJS) $$OUT/revlog_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial revlog.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/revlog_fuzzer

dirstate_fuzzer: dirstate.cc pyutil.o $(PARSERS_OBJS) $$OUT/dirstate_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial dirstate.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/dirstate_fuzzer

fm1readmarkers_fuzzer: fm1readmarkers.cc pyutil.o $(PARSERS_OBJS) $$OUT/fm1readmarkers_fuzzer_seed_corpus.zip
	$(CXX) $(CXXFLAGS) `$(PYTHON_CONFIG) --cflags` \
	  -Wno-register -Wno-macro-redefined \
	  -I../../mercurial fm1readmarkers.cc \
	  pyutil.o $(PARSERS_OBJS) \
	  $(LIB_FUZZING_ENGINE) `$(PYTHON_CONFIG) --ldflags` \
	  -o $$OUT/fm1readmarkers_fuzzer

clean:
	$(RM) *.o *_fuzzer \
	  bdiff \
	  mpatch \
	  xdiff

oss-fuzz: bdiff_fuzzer mpatch_fuzzer xdiff_fuzzer dirs_fuzzer fncache_fuzzer jsonescapeu8fast_fuzzer manifest_fuzzer revlog_fuzzer dirstate_fuzzer fm1readmarkers_fuzzer

.PHONY: all clean oss-fuzz

=== contrib/packaging/Makefile ===
$(eval HGROOT := $(shell cd ../..; pwd))

DEBIAN_CODENAMES := \
  stretch \
  buster \
  bullseye

UBUNTU_CODENAMES := \
  xenial \
  bionic \
  cosmic \
  disco

FEDORA_RELEASE := 31

CENTOS_RELEASES := \
  5 \
  6 \
  7 \
  8

# Build a Python for these CentOS releases.
CENTOS_WITH_PYTHON_RELEASES := 5 6
CENTOS_WITH_NONVERSIONED_PYTHON := 5 6 7

help:
	@echo 'Packaging Make Targets'
	@echo ''
	@echo 'docker-centos{$(strip $(CENTOS_RELEASES))}'
	@echo '   Build an RPM for a specific CentOS version using Docker.'
	@echo ''
	@echo 'docker-debian-{$(strip $(DEBIAN_CODENAMES))}'
	@echo '   Build Debian packages specific to a Debian distro using Docker.'
	@echo ''
	@echo 'docker-fedora'
	@echo '   Build an RPM for a Fedora $(FEDORA_RELEASE) using Docker.'
	@echo ''
	@echo 'docker-ubuntu-{$(strip $(UBUNTU_CODENAMES))}'
	@echo '   Build Debian package specific to an Ubuntu distro using Docker.'
	@echo ''
	@echo 'docker-ubuntu-{$(strip $(UBUNTU_CODENAMES))}-ppa'
	@echo '   Build a source-only Debian package specific to an Ubuntu distro'
	@echo '   using Docker.'
	@echo ''
	@echo 'linux-wheels'
	@echo '   Build Linux manylinux wheels using Docker.'
	@echo ''
	@echo 'linux-wheels-{x86_64, i686}'
	@echo '   Build Linux manylinux wheels for a specific architecture using Docker'
	@echo ''
	@echo 'deb'
	@echo '   Build a Debian package locally targeting the current system'
	@echo ''
	@echo 'ppa'
	@echo '   Build a Debian source package locally targeting the current system'
	@echo ''
	@echo 'centos{$(strip $(CENTOS_RELEASES))}'
	@echo '   Build an RPM for a specific CentOS version locally'
	@echo ''
	@echo 'fedora'
	@echo '   Build an RPM for Fedora $(FEDORA_RELEASE) locally'

.PHONY: help

.PHONY: deb
deb:
	./builddeb

.PHONY: ppa
ppa:
	./builddeb --source-only

# Debian targets.
define debian_targets =
.PHONY: docker-debian-$(1)
docker-debian-$(1):
	./dockerdeb debian $(1)

endef

$(foreach codename,$(DEBIAN_CODENAMES),$(eval $(call debian_targets,$(codename))))

# Ubuntu targets.
define ubuntu_targets =
.PHONY: docker-ubuntu-$(1)
docker-ubuntu-$(1):
	./dockerdeb ubuntu $(1)

.PHONY: docker-ubuntu-$(1)-ppa
docker-ubuntu-$(1)-ppa:
	./dockerdeb ubuntu $(1) --source-only

endef

$(foreach codename,$(UBUNTU_CODENAMES),$(eval $(call ubuntu_targets,$(codename))))

# Fedora targets.
.PHONY: fedora
fedora:
	mkdir -p $(HGROOT)/packages/fedora$(FEDORA_RELEASE)
	./buildrpm
	cp $(HGROOT)/contrib/packaging/rpmbuild/RPMS/*/* $(HGROOT)/packages/fedora$(FEDORA_RELEASE)
	cp $(HGROOT)/contrib/packaging/rpmbuild/SRPMS/* $(HGROOT)/packages/fedora$(FEDORA_RELEASE)
	rm -rf $(HGROOT)/rpmbuild

.PHONY: docker-fedora
docker-fedora:
	./dockerrpm fedora$(FEDORA_RELEASE)

# CentOS targets.
define centos_targets
.PHONY: centos$(1)
centos$(1):
	mkdir -p $$(HGROOT)/packages/centos$(1)
	./buildrpm $$(if $$(filter $(1),$$(CENTOS_WITH_PYTHON_RELEASES)),--withpython,$$(if $$(filter $(1),$$(CENTOS_WITH_NONVERSIONED_PYTHON)),--python python,))
	cp $$(HGROOT)/contrib/packaging/rpmbuild/RPMS/*/* $$(HGROOT)/packages/centos$(1)
	cp $$(HGROOT)/contrib/packaging/rpmbuild/SRPMS/* $$(HGROOT)/packages/centos$(1)

.PHONY: docker-centos$(1)
docker-centos$(1):
	./dockerrpm centos$(1) $$(if $$(filter $(1),$$(CENTOS_WITH_PYTHON_RELEASES)),--withpython,$$(if $$(filter $(1),$$(CENTOS_WITH_NONVERSIONED_PYTHON)),--python python,))

endef

$(foreach release,$(CENTOS_RELEASES),$(eval $(call centos_targets,$(release))))

.PHONY: linux-wheels
linux-wheels: linux-wheels-x86_64 linux-wheels-i686

.PHONY: linux-wheels-x86_64
linux-wheels-x86_64:
	docker run -e "HGTEST_JOBS=$(shell nproc)" --rm -ti -v `pwd`/../..:/src quay.io/pypa/manylinux1_x86_64 /src/contrib/packaging/build-linux-wheels.sh

.PHONY: linux-wheels-i686
linux-wheels-i686:
	docker run -e "HGTEST_JOBS=$(shell nproc)" --rm -ti -v `pwd`/../..:/src quay.io/pypa/manylinux1_i686 linux32 /src/contrib/packaging/build-linux-wheels.sh

=== contrib/packaging/requirements.txt ===
#
# This file is autogenerated by pip-compile
# To update, run:
#
#    pip-compile --generate-hashes --output-file=contrib/packaging/requirements.txt contrib/packaging/requirements.txt.in
#
jinja2==2.10.3 \
    --hash=sha256:74320bb91f31270f9551d46522e33af46a80c3d619f4a4bf42b3164d30b5911f \
    --hash=sha256:9fe95f19286cfefaa917656583d020be14e7859c6b0252588391e47db34527de
markupsafe==1.1.1 \
    --hash=sha256:00bc623926325b26bb9605ae9eae8a215691f33cae5df11ca5424f06f2d1f473 \
    --hash=sha256:09027a7803a62ca78792ad89403b1b7a73a01c8cb65909cd876f7fcebd79b161 \
    --hash=sha256:09c4b7f37d6c648cb13f9230d847adf22f8171b1ccc4d5682398e77f40309235 \
    --hash=sha256:1027c282dad077d0bae18be6794e6b6b8c91d58ed8a8d89a89d59693b9131db5 \
    --hash=sha256:24982cc2533820871eba85ba648cd53d8623687ff11cbb805be4ff7b4c971aff \
    --hash=sha256:29872e92839765e546828bb7754a68c418d927cd064fd4708fab9fe9c8bb116b \
    --hash=sha256:43a55c2930bbc139570ac2452adf3d70cdbb3cfe5912c71cdce1c2c6bbd9c5d1 \
    --hash=sha256:46c99d2de99945ec5cb54f23c8cd5689f6d7177305ebff350a58ce5f8de1669e \
    --hash=sha256:500d4957e52ddc3351cabf489e79c91c17f6e0899158447047588650b5e69183 \
    --hash=sha256:535f6fc4d397c1563d08b88e485c3496cf5784e927af890fb3c3aac7f933ec66 \
    --hash=sha256:62fe6c95e3ec8a7fad637b7f3d372c15ec1caa01ab47926cfdf7a75b40e0eac1 \
    --hash=sha256:6dd73240d2af64df90aa7c4e7481e23825ea70af4b4922f8ede5b9e35f78a3b1 \
    --hash=sha256:717ba8fe3ae9cc0006d7c451f0bb265ee07739daf76355d06366154ee68d221e \
    --hash=sha256:79855e1c5b8da654cf486b830bd42c06e8780cea587384cf6545b7d9ac013a0b \
    --hash=sha256:7c1699dfe0cf8ff607dbdcc1e9b9af1755371f92a68f706051cc8c37d447c905 \
    --hash=sha256:88e5fcfb52ee7b911e8bb6d6aa2fd21fbecc674eadd44118a9cc3863f938e735 \
    --hash=sha256:8defac2f2ccd6805ebf65f5eeb132adcf2ab57aa11fdf4c0dd5169a004710e7d \
    --hash=sha256:98c7086708b163d425c67c7a91bad6e466bb99d797aa64f965e9d25c12111a5e \
    --hash=sha256:9add70b36c5666a2ed02b43b335fe19002ee5235efd4b8a89bfcf9005bebac0d \
    --hash=sha256:9bf40443012702a1d2070043cb6291650a0841ece432556f784f004937f0f32c \
    --hash=sha256:ade5e387d2ad0d7ebf59146cc00c8044acbd863725f887353a10df825fc8ae21 \
    --hash=sha256:b00c1de48212e4cc9603895652c5c410df699856a2853135b3967591e4beebc2 \
    --hash=sha256:b1282f8c00509d99fef04d8ba936b156d419be841854fe901d8ae224c59f0be5 \
    --hash=sha256:b2051432115498d3562c084a49bba65d97cf251f5a331c64a12ee7e04dacc51b \
    --hash=sha256:ba59edeaa2fc6114428f1637ffff42da1e311e29382d81b339c1817d37ec93c6 \
    --hash=sha256:c8716a48d94b06bb3b2524c2b77e055fb313aeb4ea620c8dd03a105574ba704f \
    --hash=sha256:cd5df75523866410809ca100dc9681e301e3c27567cf498077e8551b6d20e42f \
    --hash=sha256:e249096428b3ae81b08327a63a485ad0878de3fb939049038579ac0ef61e17e7 \
    # via jinja2

=== debian/changelog ===
mercurial (5.3.1-1ubuntu1) focal; urgency=medium

  * Merge with Debian; remaining changes:
    - Explictly call python2 instead of python

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Mar 2020 21:04:26 +0100

mercurial (5.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - drop proposed_upstream__correct-zeroconf-doc, included upstream.
  * Stop moving the help text and templates to /usr/share/mercurial, doesn't
    work right with the changes in 5.3 and isn't worth the effort.

 -- Julien Cristau <jcristau@debian.org>  Fri, 06 Mar 2020 10:38:36 +0100

=== debian/control ===
Source: mercurial
Section: vcs
Priority: optional
Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
Uploaders:
 Vincent Danjean <vdanjean@debian.org>,
 Javi Merino <vicho@debian.org>,
 Tristan Seligmann <mithrandi@debian.org>,
Build-Depends:
 bash-completion,
 debhelper-compat (= 9),
 dh-python,
 gettext,
 netbase,
 patchutils (>= 0.2.25),
 python-all-dev (>= 2.6.6-3~),
 python-docutils,
 python-roman,
 rename,
 unzip,
 zip,
 less <!nocheck>,
Standards-Version: 4.0.0
Homepage: https://www.mercurial-scm.org/
Vcs-Git: https://salsa.debian.org/python-team/applications/mercurial.git
Vcs-Browser: https://salsa.debian.org/python-team/applications/mercurial

Package: mercurial-common
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Recommends: ca-certificates, mercurial (>= ${source:Version}), sensible-utils
Suggests: python-mysqldb, python-openssl, python-pygments, wish
Breaks: mercurial (<< ${source:Version})
Replaces: mercurial (<< 2.6.3)
Description: easy-to-use, scalable distributed version control system (common files)
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 This package contains the architecture independent components of Mercurial,
 and is generally useless without the mercurial package.

Package: mercurial
Architecture: any
Depends:
 mercurial-common (= ${source:Version}),
 ucf (>= 2.0020),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Recommends: openssh-client
Suggests: kdiff3 | kdiff3-qt | kompare | meld | tkcvs | mgdiff, qct
Breaks:
 hgsubversion (<< 1.9.3+git20190419+6a6ce-2~),
 hgview-common (<< 1.8.1),
 mercurial-crecord (<= 0.20140626-1),
 mercurial-git (<= 0.8.12-1.),
 qct (<< 1.7-2~),
Description: easy-to-use, scalable distributed version control system
 Mercurial is a fast, lightweight Source Control Management system designed
 for efficient handling of very large distributed projects.
 .
 Its features include:
  * O(1) delta-compressed file storage and retrieval scheme
  * Complete cross-indexing of files and changesets for efficient exploration
    of project history
  * Robust SHA1-based integrity checking and append-only storage model
  * Decentralized development model with arbitrary merging between trees
  * High-speed HTTP-based network merge protocol
  * Easy-to-use command-line interface
  * Integrated stand-alone web interface
  * Small Python codebase
 .
 This package contains the architecture dependent files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with python2,bash-completion

export PYTHON=python2
PYVERS=$(shell pyversions -vs)
PYVER_DEFAULT=$(shell pyversions -vd)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
ifeq ($(DEB_HOST_ARCH),mips64el)
        # Work around #871514
        export DEB_CFLAGS_MAINT_APPEND = -mno-lra
endif

override_dh_auto_build:
	$(MAKE) all
	# Do not start a line with a word with a dot in a manpage
	sed -i -e 's,^[.]\(hgignore\|hg/hgrc\),\\fP\1,' doc/hg.1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NJOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         PARALLEL_TEST_JOBS := --jobs $(NJOBS)
endif

ARCH_IS_MIPS := $(if $(subst mips,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_KFREEBSD-i386 := $(if $(subst kfreebsd-i386,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_ARMEL := $(if $(subst armel,,$(DEB_HOST_ARCH)),,T)
ARCH_IS_SPARC := $(if $(subst sparc,,$(DEB_HOST_ARCH)),,T)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# test-pull-pull-corruption tries to execute two hg commands at the
# same time to test for corruption.  It does so by running an hg
# command in the background, sleeping one second and running the
# second command.  In architectures with slow buildds, one second is
# not enough and the second test starts before the first one has
# started printing.  This is hacky and we just enhance the hack by
# incrementing the sleep time in those architectures.
ifneq ($(or $(ARCH_IS_MIPS), $(ARCH_IS_KFREEBSD-i386), $(ARCH_IS_ARMEL), $(ARCH_IS_SPARC)),)
		sed -i.deb-backup -e 's/sleep 1/sleep 2/' $(CURDIR)/tests/test-pull-pull-corruption.t
endif

	http_proxy='' dh_auto_test -- TESTFLAGS="--verbose --timeout 1440 $(PARALLEL_TEST_JOBS) --blacklist $(CURDIR)/debian/mercurial.test_blacklist"
	file-rename 's/\.deb-backup$$//' $(CURDIR)/tests/*
	# run blacklisted tests but ignore their results
	-cd tests && python2 run-tests.py --verbose `grep ^test ../debian/mercurial.test_blacklist`
endif

override_dh_auto_install: $(PYVERS:%=install-python%)

install-python%:
	python$* setup.py install --root $(CURDIR)/debian/tmp --install-layout=deb

override_dh_install:
	dh_install
	if test -d $(CURDIR)/debian/mercurial ; then \
		$(MAKE) -f debian/rules install-archdep ; \
	fi
	if test -d $(CURDIR)/debian/mercurial-common ; then \
		$(MAKE) -f debian/rules install-archindep ;\
	fi

install-archdep:
	# remove arch-independent python stuff
	find debian/mercurial/usr/lib \
		! -name '*.so' ! -type d -delete , \
		-type d -empty -delete

install-archindep:
	# remove arch-dependent python stuff
	find debian/mercurial-common/usr/lib \
		-name '*.so' ! -type d -delete , \
		-type d -empty -delete

override_dh_auto_clean: mercurial/__version__.py
	cp -a mercurial/__version__.py mercurial/__version__.py.save
	dh_auto_clean
	mv mercurial/__version__.py.save mercurial/__version__.py
	$(RM) -rv tmp/

mercurial/__version__.py:
	@echo "$@ is missing (you probably call 'make clean' directly)."
	@echo "Restore it from sources before building the package"
	@echo "Aborting."
	exit 1

=== debian/tests/control ===
Tests: testsuite
Depends:
    @,
    zip,
    unzip,
    netbase,
    subversion,
    python-subversion,
    cvs,
    bzr,
    tla,
    git,
    darcs,
    gcc,
    python2.7-dev,
    less,
    gettext,
    pylint,
    python-pygments,
    python-docutils,
    sqlite3,
    clang-format,
#   python-vcr, (https://tracker.debian.org/news/1056660/accepted-vcrpy-201-4-source-into-unstable/)
#   python-fuzzywuzzy, (Bug#936574)
#   black (>= 19.10b0), (Bug#944292)
Restrictions: allow-stderr

## mercurial 5.4

=== debian/changelog ===
mercurial (5.4-1ubuntu1) groovy; urgency=medium

  * Merge with Debian; remaining changes:
    - Explictly call python2 instead of python

 -- Matthias Klose <doko@ubuntu.com>  Wed, 03 Jun 2020 10:29:41 +0200

mercurial (5.4-1) unstable; urgency=medium

  * Team upload.

  [ Philippe Pepiot ]
  * Ship the chg binary (closes: #926384).  chg can be used as an
    alternative "hg" command, it spawns a mercurial server and uses a
    lightweight client written in C.

  [ Julien Cristau ]
  * Add Pulkit Goyal's key (EB851395B4223EE2F7BA0B28DA54740BF08732BA) to
    the keyring for upstream tarball signatures.
  * New upstream release.
  * Fix test-doctest.py now assuming it's being run from a hg repo.
  * autopkgtests: explicitly run the testsuite with python2.

 -- Julien Cristau <jcristau@debian.org>  Thu, 21 May 2020 12:35:06 +0200

mercurial (5.3.2-1) unstable; urgency=medium

  * New upstream release

 -- Julien Cristau <jcristau@debian.org>  Thu, 16 Apr 2020 10:35:09 +0200

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 
 override_dh_auto_build:
 	$(MAKE) all
+	$(MAKE) -C contrib/chg all
 	# Do not start a line with a word with a dot in a manpage
 	sed -i -e 's,^[.]\(hgignore\|hg/hgrc\),\\fP\1,' doc/hg.1

## mercurial 5.4.1

=== debian/changelog ===
mercurial (5.4.1-1+exp1ubuntu1) groovy; urgency=medium

  * Blacklist for test-wireproto-exchangev2-shallow.t for occasional
    failures.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 10 Jul 2020 02:05:50 +0100

mercurial (5.4.1-1+exp1) experimental; urgency=medium

  * Upload to experimental a python3 version of mercurial

 -- Sandro Tosi <morph@debian.org>  Sat, 04 Jul 2020 21:12:04 -0400

mercurial (5.4.1-1) unstable; urgency=medium

  * Team upload.
  * Remove python-subversion from autopkgtest dependencies
    (closes: #956007)
  * New upstream bugfix release.
  * Fix test-clone-uncompressed.t failure on slow/loaded hosts.
  * Blacklist test-narrow-shallow.t for occasional failures.
  * Blacklist test-debugcommands.t for occasional failures.

 -- Julien Cristau <jcristau@debian.org>  Thu, 25 Jun 2020 12:18:13 +0200

mercurial (5.4-2) unstable; urgency=medium

  * Team upload.
  * Blacklist test-nointerrupt.t for being racy.
  * Don't install the hgext.git extension as that namespace is used by
    the mercurial-git package, and ours is still very experimental.
    Closes: #961245

 -- Julien Cristau <jcristau@debian.org>  Thu, 18 Jun 2020 15:38:51 +0200

mercurial (5.4-1+exp1) experimental; urgency=medium

  * Team upload.
  * Use python3 (closes: #937009).
  * mercurial Provides python3-mercurial so extensions can depend on
    that instead of a hazardous versioned dependency.
  * Add Breaks on all extensions.  To be updated as we don't know what
    version will use python3.

 -- Julien Cristau <jcristau@debian.org>  Thu, 21 May 2020 12:44:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mercurial
 Section: vcs
 Priority: optional
-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Uploaders:
  Vincent Danjean <vdanjean@debian.org>,
  Javi Merino <vicho@debian.org>,
@@ -13,9 +14,9 @@
  gettext,
  netbase,
  patchutils (>= 0.2.25),
- python-all-dev (>= 2.6.6-3~),
- python-docutils,
- python-roman,
+ python3-all-dev,
+ python3-docutils,
+ python3-roman,
  rename,
  unzip,
  zip,
@@ -27,9 +28,9 @@
 
 Package: mercurial-common
 Architecture: all
-Depends: ${misc:Depends}, ${python:Depends}
+Depends: ${misc:Depends}, ${python3:Depends}
 Recommends: ca-certificates, mercurial (>= ${source:Version}), sensible-utils
-Suggests: python-mysqldb, python-openssl, python-pygments, wish
+Suggests: python3-mysqldb, python3-openssl, python3-pygments, wish
 Breaks: mercurial (<< ${source:Version})
 Replaces: mercurial (<< 2.6.3)
 Description: easy-to-use, scalable distributed version control system (common files)
@@ -45,16 +46,21 @@
  mercurial-common (= ${source:Version}),
  ucf (>= 2.0020),
  ${misc:Depends},
- ${python:Depends},
+ ${python3:Depends},
  ${shlibs:Depends},
 Recommends: openssh-client
 Suggests: kdiff3 | kdiff3-qt | kompare | meld | tkcvs | mgdiff, qct
 Breaks:
- hgsubversion (<< 1.9.3+git20190419+6a6ce-2~),
- hgview-common (<< 1.8.1),
- mercurial-crecord (<= 0.20140626-1),
- mercurial-git (<= 0.8.12-1.),
- qct (<< 1.7-2~),
+ hgsubversion (<= 1.9.3+git20190419+6a6ce-3),
+ hgview-common,
+ mercurial-crecord (<= 0.20151121-2),
+ mercurial-git (<= 0.8.12-1.2),
+ qct,
+ mercurial-keyring (<= 1.3.0-1),
+ mercurial-server,
+ python-sphinx-patchqueue,
+ trac-mercurial,
+Provides: python3-mercurial
 Description: easy-to-use, scalable distributed version control system
  Mercurial is a fast, lightweight Source Control Management system designed
  for efficient handling of very large distributed projects.

=== debian/rules ===
--- 
+++ 
@@ -5,19 +5,21 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@ --with python2,bash-completion
+	dh $@ --with python3,bash-completion
 
-export PYTHON=python2
-PYVERS=$(shell pyversions -vs)
-PYVER_DEFAULT=$(shell pyversions -vd)
+PYVERS=$(shell py3versions -vs)
+PYVER_DEFAULT=$(shell py3versions -vd)
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 ifeq ($(DEB_HOST_ARCH),mips64el)
         # Work around #871514
         export DEB_CFLAGS_MAINT_APPEND = -mno-lra
 endif
 
+override_dh_python3:
+	dh_python3 --shebang=/usr/bin/python3
+
 override_dh_auto_build:
-	$(MAKE) all
+	$(MAKE) all PYTHON=python$(PYVER_DEFAULT)
 	$(MAKE) -C contrib/chg all
 	# Do not start a line with a word with a dot in a manpage
 	sed -i -e 's,^[.]\(hgignore\|hg/hgrc\),\\fP\1,' doc/hg.1
@@ -45,13 +47,16 @@
 		sed -i.deb-backup -e 's/sleep 1/sleep 2/' $(CURDIR)/tests/test-pull-pull-corruption.t
 endif
 
-	http_proxy='' dh_auto_test -- TESTFLAGS="--verbose --timeout 1440 $(PARALLEL_TEST_JOBS) --blacklist $(CURDIR)/debian/mercurial.test_blacklist"
+	http_proxy='' dh_auto_test -- PYTHON=python$(PYVER_DEFAULT) TESTFLAGS="--verbose --timeout 1440 $(PARALLEL_TEST_JOBS) --blacklist $(CURDIR)/debian/mercurial.test_blacklist"
 	file-rename 's/\.deb-backup$$//' $(CURDIR)/tests/*
 	# run blacklisted tests but ignore their results
-	-cd tests && python2 run-tests.py --verbose `grep ^test ../debian/mercurial.test_blacklist`
+	-cd tests && python3 run-tests.py --verbose `grep ^test ../debian/mercurial.test_blacklist`
 endif
 
 override_dh_auto_install: $(PYVERS:%=install-python%)
+	# #961245: mercurial-git grabbed the hgext/git directory years
+	# ago, so don't install our experimental extension there for now
+	rm -rf debian/tmp/usr/lib/python*/*-packages/hgext/git
 
 install-python%:
 	python$* setup.py install --root $(CURDIR)/debian/tmp --install-layout=deb
@@ -77,9 +82,13 @@
 		-name '*.so' ! -type d -delete , \
 		-type d -empty -delete
 
+override_dh_python3-arch:
+	dh_python3
+	find debian/mercurial/usr/share -type d -empty -delete ; \
+
 override_dh_auto_clean: mercurial/__version__.py
 	cp -a mercurial/__version__.py mercurial/__version__.py.save
-	dh_auto_clean
+	dh_auto_clean -- PYTHON=python3
 	mv mercurial/__version__.py.save mercurial/__version__.py
 	$(RM) -rv tmp/

=== debian/tests/control ===
Tests: testsuite
Depends:
    @,
    zip,
    unzip,
    netbase,
    subversion,
#    python3-subversion,
    cvs,
    bzr,
    tla,
    git,
    darcs,
    gcc,
    python3-dev,
    less,
    gettext,
    pylint3,
    python3-pygments,
    python3-docutils,
    sqlite3,
    clang-format,
    python3-vcr,
    python3-fuzzywuzzy,
    black (>= 19.10b0),
Restrictions: allow-stderr

## mercurial 5.5

=== debian/changelog ===
mercurial (5.5-2) unstable; urgency=medium

  * (Hopefully) fix flakiness in test-stdio.py.

 -- Tristan Seligmann <mithrandi@debian.org>  Mon, 17 Aug 2020 10:33:16 +0200

mercurial (5.5-1) unstable; urgency=medium

  * New upstream release.
    - Fix Python 3 issues with hgext.convert.subversion (closes: #968466).
  * Install zsh completion to vendor-completions (closes: #963253).
  * Install run-tests.py for downstream packages to use (closes: #930488).

 -- Tristan Seligmann <mithrandi@debian.org>  Sun, 16 Aug 2020 17:00:20 +0200

mercurial (5.4.1-3) unstable; urgency=medium

  * Trim trailing whitespace.
  * Bump debhelper from deprecated 9 to 13.
  * Rely on pre-initialized dpkg-architecture variables.
  * Set Rules-Requires-Root: no.
  * Adjust Breaks: mercurial-crecord (closes: #968035).
  * Remove unused debian/source/include-binaries.
  * Bump Standards-Version to 4.5.0.
  * Blacklist test-check-format.t.
  * Blacklist test-wireproto-exchangev2-shallow.t.

 -- Tristan Seligmann <mithrandi@debian.org>  Mon, 10 Aug 2020 23:06:15 -0000

mercurial (5.4.1-2) unstable; urgency=medium

  * Upload to unstable, switch to python3; Closes: #937009, #948610

 -- Sandro Tosi <morph@debian.org>  Thu, 16 Jul 2020 15:05:37 -0400

## mercurial 5.5.1

=== debian/changelog ===
mercurial (5.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream bugfix release.

 -- Julien Cristau <jcristau@debian.org>  Wed, 02 Sep 2020 10:26:16 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: mercurial
 Section: vcs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
+Maintainer: Python Applications Packaging Team <python-apps-team@lists.alioth.debian.org>
 Uploaders:
  Vincent Danjean <vdanjean@debian.org>,
  Javi Merino <vicho@debian.org>,
  Tristan Seligmann <mithrandi@debian.org>,
 Build-Depends:
  bash-completion,
- debhelper-compat (= 9),
+ debhelper-compat (= 13),
  dh-python,
  gettext,
  netbase,
@@ -21,10 +20,11 @@
  unzip,
  zip,
  less <!nocheck>,
-Standards-Version: 4.0.0
+Standards-Version: 4.5.0
 Homepage: https://www.mercurial-scm.org/
 Vcs-Git: https://salsa.debian.org/python-team/applications/mercurial.git
 Vcs-Browser: https://salsa.debian.org/python-team/applications/mercurial
+Rules-Requires-Root: no
 
 Package: mercurial-common
 Architecture: all
@@ -53,7 +53,7 @@
 Breaks:
  hgsubversion (<= 1.9.3+git20190419+6a6ce-3),
  hgview-common,
- mercurial-crecord (<= 0.20151121-2),
+ mercurial-crecord (<< 0.20151121-2~),
  mercurial-git (<= 0.8.12-1.2),
  qct,
  mercurial-keyring (<= 1.3.0-1),

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 PYVERS=$(shell py3versions -vs)
 PYVER_DEFAULT=$(shell py3versions -vd)
-DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
 ifeq ($(DEB_HOST_ARCH),mips64el)
         # Work around #871514
         export DEB_CFLAGS_MAINT_APPEND = -mno-lra
@@ -61,8 +61,7 @@
 install-python%:
 	python$* setup.py install --root $(CURDIR)/debian/tmp --install-layout=deb
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 	if test -d $(CURDIR)/debian/mercurial ; then \
 		$(MAKE) -f debian/rules install-archdep ; \
 	fi
@@ -81,6 +80,10 @@
 	find debian/mercurial-common/usr/lib \
 		-name '*.so' ! -type d -delete , \
 		-type d -empty -delete
+	install -DTm 644 contrib/zsh_completion \
+	    debian/mercurial-common/usr/share/zsh/vendor-completions/_mercurial
+	install -DTm 644 tests/run-tests.py \
+	    debian/mercurial-common/usr/share/mercurial/tests/run-tests.py
 
 override_dh_python3-arch:
 	dh_python3
@@ -97,4 +100,3 @@
 	@echo "Restore it from sources before building the package"
 	@echo "Aborting."
 	exit 1
-
